/*
 * Select proper fp executable based on the name of this executable
 *
 * if name is xxxx/fpsrrvadm.suid.exe, execute basename/bin/fpsrrvadm.exe
 * if name is xxxx/admin.exe, execute 
 *      basename/extensions/_vti_bin/_vti_adm/admin.exe
 * if name is xxxx/author.exe, execute
 *      basename/extensions/_vti_bin/_vti_aut/author.exe
 * if name is xxxx/shtml.exe, execute 
 *      basename/extensions/_vti_bin/shtml.exe
 * if name is xxxx/fpcount.exe, execute 
 *      basename/extensions/_vti_bin/fpcount.exe
 * for anything else, error
 *
 * Copyright (c) 1996-1997 Microsoft Corporation, All Rights Reserved
 *
 * NO WARRANTIES. Microsoft expressly disclaims any warranty for this code and
 * information. This code and information and any related documentation is
 * provided "as is" without warranty of any kind, either express or implied,
 * including, without limitation, the implied warranties or merchantability,
 * fitness for a particular purpose, or noninfringement. The entire risk
 * arising out of use or performance of this code and information remains with
 * you.
 *
 * NO LIABILITY FOR DAMAGES. In no event shall Microsoft or its suppliers be
 * liable for any damages whatsoever (including, without limitation, damages
 * for loss of business profits, business interruption, loss of business
 * information, or any other pecuniary loss) arising out of the use of or
 * inability to use this Microsoft product, even if Microsoft has been advised
 * of the possibility of such damages. Because some states/jurisdictions do not
 * allow the exclusion or limitation of liability for consequential or
 * incidental damages, the above limitation may not apply to you.
 *
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>

#if !defined(MIPS_LINUX)
char * basename (char *);
#endif

int
main(int argc,char **argv)
{
    char work[80];
    char * base;

    for (base = argv[0] + strlen(argv[0]) + 1;
         (base > argv[0]) && (*(base -1) != '/');
         base--);

    strcpy (work, "/usr/local/frontpage/version4.0/");

    if (!strcmp("shtml.exe", base))
        strcat (work, "exes/_vti_bin/shtml.exe");

    else if (!strcmp("fpcount.exe", base))
        strcat (work, "exes/_vti_bin/fpcount.exe");

    else if (!strcmp("author.exe", base))
        strcat (work, "exes/_vti_bin/_vti_aut/author.exe");

    else if (!strcmp("admin.exe", base))
        strcat (work, "exes/_vti_bin/_vti_adm/admin.exe");

    else if (!strcmp("fpsrvadm.suid.exe", base))
        strcat (work, "bin/fpsrvadm.exe");

    else
    {
        fprintf(stderr, "Invalid use of FrontPage SUID stub");
        exit(1);
    }

    umask(022);
    argv[0] = work;
    execv(argv[0], argv);
    return (1);
}
